--- /usr/share/initramfs-tools/hooks/cryptroot.orig
+++ /usr/share/initramfs-tools/hooks/cryptroot
@@ -230,6 +230,9 @@
 			lvm=*)
 				OPTIONS="$OPTIONS,$opt"
 				;;
+			lvm_vg=*)
+				OPTIONS="$OPTIONS,$opt"
+				;;
 			keyscript=*)
 				opt=${opt#keyscript=}
 				if [ ! -x "/lib/cryptsetup/scripts/$opt" ] && [ ! -x "$opt" ]; then
@@ -338,7 +341,7 @@
 }
 
 add_device() {
-	local node nodes opts lastopts i count
+	local node nodes node_deps node_maj node_min node_depnode node_vg opts lastopts i count
 	nodes="$1"
 	opts=""     # Applied to all nodes
 	lastopts="" # Applied to last node
@@ -374,6 +377,18 @@
 		nodes="$lvmnodes"
 	fi
 
+	# Check for dm-crypt on lvm
+	node_deps=$(dmsetup deps "$nodes" 2>/dev/null | sed 's/[^:]*: *//;s/[ (]//g;s/)/ /g')
+	if [ -n "$node_deps" ]; then
+		node_maj=$(echo ${node_deps%,*} | sed -e "s/^[ \t]*//g")
+		node_min=$(echo ${node_deps#*,} | sed -e "s/[ \t]*$//g")
+		node_depnode=$(dmsetup ls | sed -n "s/\\([^ ]*\\) *($node_maj, $node_min)/\\1/p" | sed -e "s/[ \t]*$//")
+		node_vg=$(lvdisplay "/dev/mapper/$node_depnode" 2>/dev/null | sed -r -e "s|^ +VG Name +([^ ]+) *$|\1|;tx;d;:x")
+		if [ -n "$node_vg" ]; then
+			lastopts="lvm_vg=$node_vg"
+		fi
+	fi
+
 	# Prepare to setup each node
 	count=$(echo "$nodes" | wc -w)
 	i=1
